#include "stdafx.h"
#include "Logger.h"
 

Logger::Logger() {
	// ĬϹ캯
	this->target = terminal;
	this->level = debug;
	cout << "[WELCOME] " << __FILE__ << " " << currTime() << " : " << "=== Start logging ===" << endl;
}

Logger::Logger(log_target target, log_level level, string path) {
	this->target = target;
	this->path = path;
	this->level = level;
	string tmp = "";  // ˫µĳֱӣһstringת
	string welcome_dialog = tmp + "[Welcome] " + __FILE__ + " " + currTime() + " : " + "=== Start logging ===\n";
	if (target != terminal) {
		this->outfile.open(path, ios::out | ios::app);   // ļ
		this->outfile << welcome_dialog;
	}
	if (target != file) {
		// ־ǽļ
		cout << welcome_dialog;
	}
}

void Logger::output(string text, log_level act_level) {
	string prefix;
	if (act_level == debug) prefix = "[DEBUG]   ";
	else if (act_level == info) prefix = "[INFO]    ";
	else if (act_level == warning) prefix = "[WARNING] ";
	else if (act_level == error) prefix = "[ERROR]   ";
	else prefix = "";
	prefix += __FILE__;
	prefix += " ";
	string output_content = prefix + currTime() + " : " + text + "\n";
	if (this->level <= act_level && this->target != file) {
		// ǰȼ趨ĵȼŻʾնˣҲֻļģʽ
		cout << output_content;
	}
	if (this->target != terminal)
		outfile << output_content;
}


void Logger::DEBUG(string text) {
	this->output(text, debug);
}

void Logger::INFO(string text) {
	this->output(text, info);
}

void Logger::WARNING(string text) {
	this->output(text, warning);
}

void Logger::LERROR(string text) {
	this->output(text, error);
}
